package sun.security.pkcs10;

import java.io.OutputStream;
import java.io.IOException;
import sun.security.pkcs.PKCS9Attribute;
import sun.security.util.DerValue;
import sun.security.util.ObjectIdentifier;
import sun.security.util.DerEncoder;

public class PKCS10Attribute implements DerEncoder
{
    protected ObjectIdentifier attributeId;
    protected Object attributeValue;
    
    public PKCS10Attribute(DerValue derVal) throws IOException {
        this.attributeId = null;
        this.attributeValue = null;
        PKCS9Attribute pkcs9Attribute = new PKCS9Attribute(derVal);
        this.attributeId = pkcs9Attribute.getOID();
        this.attributeValue = pkcs9Attribute.getValue();
    }
    
    public PKCS10Attribute(ObjectIdentifier attributeId, Object attributeValue) {
        this.attributeId = null;
        this.attributeValue = null;
        this.attributeId = attributeId;
        this.attributeValue = attributeValue;
    }
    
    public PKCS10Attribute(PKCS9Attribute pkcs9Attribute) {
        this.attributeId = null;
        this.attributeValue = null;
        this.attributeId = pkcs9Attribute.getOID();
        this.attributeValue = pkcs9Attribute.getValue();
    }
    
    public void derEncode(OutputStream outputStream) throws IOException {
        new PKCS9Attribute(this.attributeId, this.attributeValue).derEncode(outputStream);
    }
    
    public ObjectIdentifier getAttributeId() {
        return this.attributeId;
    }
    
    public Object getAttributeValue() {
        return this.attributeValue;
    }
    
    @Override
    public String toString() {
        return this.attributeValue.toString();
    }
}
